#include "APU.h"
//#include "InfoNES_pAPU.h"
char APUREG[20];

/*-------------------------------------------------------------------*/
/* Rectangle Wave #0                                                 */
/* Reg0: 0-3=Volume, 4=Envelope, 5=Hold, 6-7=Duty Cycle              */
/* Reg1: 0-2=sweep shifts, 3=sweep inc, 4-6=sweep length, 7=sweep on */
/* Reg2: freq_low 8 bits of freq                                              */
/* Reg3: 0-2=high freq, 7-4=vbl length counter                       */
/*-------------------------------------------------------------------*/
#define ApuC1Vol            ( APUREG[0] & 0x0f )     // $4000
#define ApuC1Env            ( APUREG[0] & 0x10 )
#define ApuC1Hold           ( APUREG[0] & 0x20 )
#define ApuC1DutyCycle      ( APUREG[0] & 0xc0 )

#define ApuC1SweepShifts    ( APUREG[1] & 0x07 )     // $4001
#define ApuC1SweepIncDec    ( APUREG[1] & 0x08 )
#define ApuC1Sweep_length   ( APUREG[1] & 0x70 )
#define ApuC1SweepOn        ( APUREG[1] & 0x80 )

#define ApuC1_freq_low      ( APUREG[2])             // $4002

#define ApuC1_high_freq     ( APUREG[3] & 0x07 )     // $4003
#define ApuC1_length_count  ( APUREG[3] & 0xF8 )

#define ApuC1FreqLimit      ( (APUREG[3] & 0x07) << 8 | APUREG[2] )


int timer_pulse_1;
int freq;

void lcd_clear(void){
  TFT_Set_Brush(1, CL_BLACK, 0, 0, 0, 0);
  TFT_Set_Pen(CL_BLACK, 1);
  TFT_Rectangle(0, 120, 100, 230);
}

BYTE APU_Read(WORD addr)
{
        BYTE str=0;
        if(addr==0x4017)str=(1<<6);
        return str;

}
        /*lcd_clear();
        sprintf(lcd_buff, "%i",str);
        TFT_Write_Text(lcd_buff,0,0);*/
        
void APU_Write(WORD addr, BYTE str)
{
char lcd_buff[32];


        if( addr >= 0x4000 && addr <= 0x401F ) {
        GPIOB_ODR.B2 =~GPIOB_ODR.B2;
        
        APUREG[addr & 0xFF] = str;
        /*
        lcd_clear();
        sprintf(lcd_buff, "%i %i %i %i",ApuC1Vol, ApuC1Env, ApuC1Hold, ApuC1DutyCycle);
        TFT_Write_Text(lcd_buff,0,120);

        sprintf(lcd_buff, "%i %i %i %i",ApuC1SweepShifts, ApuC1SweepIncDec, ApuC1Sweep_length, ApuC1SweepOn);
        TFT_Write_Text(lcd_buff,0,135);
        
        sprintf(lcd_buff, "%i",ApuC1_freq_low);
        TFT_Write_Text(lcd_buff,0,150);
        
        sprintf(lcd_buff, "%i %i",ApuC1_high_freq, ApuC1_length_count);
        TFT_Write_Text(lcd_buff,0,165);
        
        sprintf(lcd_buff, "%i",ApuC1FreqLimit);
        TFT_Write_Text(lcd_buff,0,180);
        
        freq = 2047-ApuC1FreqLimit;
        
        sprintf(lcd_buff, "%i",freq);
        TFT_Write_Text(lcd_buff,0,195);
        */
        }
        //freq = 2047-ApuC1FreqLimit;
        //Sound_Play(freq, 1);
        //Sound_Play(freq, ApuC1DutyCycle);
        //DAC1_Advanced_Ch1_Output(ApuC1FreqLimit, _DAC_12_BIT | _DAC_RIGHT_ALIGN | _DAC_MMAP_4095 | _DAC_TRIGGER_SW);
        //DAC1_Advanced_Ch2_Output(ApuC1FreqLimit, _DAC_12_BIT | _DAC_RIGHT_ALIGN | _DAC_MMAP_4095 | _DAC_TRIGGER_SW);
}