/*===================================================================*/
/*                                                                   */
/*  InfoNES_pAPU.cpp : InfoNES Sound Emulation Function              */
/*                                                                   */
/*  2000/05/29  InfoNES Project ( based on DarcNES and NesterJ )     */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/*  Include files                                                    */
/*-------------------------------------------------------------------*/
#include <built_in.h>
#include <stdint.h>
#include "InfoNES_pAPU.h"
//#include "dac.h"
//#include "timer.h"

DWORD   clocks = 100;
unsigned int DApc;
/*-------------------------------------------------------------------*/
/*   APU resources                                                   */
/*-------------------------------------------------------------------*/
ApuResource         APU;

ApuEvent            ApuEventQueue[APU_EVENT_MAX*sizeof(ApuEvent)];
BYTE                APU_Reg4015;//24  APU
BYTE                wave_buffers[4][MAX_PCM];        //44100 / 60 = 735 samples per sync
volatile BYTE       Abuf[Framemun][MAX_PCM+1];

//BYTE  APU_Mute;//APU Mute(0:OFF,1:ON)

volatile BYTE       Done;
BYTE                whichbuf;
BYTE                zheng;

/*-------------------------------------------------------------------*/
/*  Wave str                                                        */
/*-------------------------------------------------------------------*/
const ApuQualityData ApuQual[] = {
   {0xa2567000, 0xa2567000, 0xa2567000, 183, 164, 11025, 1062658},
   {0x512b3800, 0x512b3800, 0x512b3800, 367,  82, 22050, 531329 },
   {0x289d9c00, 0x289d9c00, 0x289d9c00, 735,  41, 44100, 265664 }
};

const BYTE pulse_25[0x20] = {
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
};

const BYTE pulse_50[0x20] = {
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
};

const BYTE pulse_75[0x20] = {
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00,
};

const BYTE pulse_87[0x20] = {
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x11, 0x11, 0x11, 0x11,
  0x00, 0x00, 0x00, 0x00,
};

const BYTE triangle_50[0x20] = {
  0x00, 0x10, 0x20, 0x30,
  0x40, 0x50, 0x60, 0x70,
  0x80, 0x90, 0xa0, 0xb0,
  0xc0, 0xd0, 0xe0, 0xf0,
  0xff, 0xef, 0xdf, 0xcf,
  0xbf, 0xaf, 0x9f, 0x8f,
  0x7f, 0x6f, 0x5f, 0x4f,
  0x3f, 0x2f, 0x1f, 0x0f,
};

const BYTE *pulse_waves[4] = {
  pulse_87, pulse_75, pulse_50, pulse_25,
};

/*-------------------------------------------------------------------*/
/*  Active Time Left str                                            */
/*-------------------------------------------------------------------*/
const BYTE ApuAtl[0x20] = 
{
  5, 127, 10, 1, 19,  2, 40,  3, 80,  4, 30,  5, 7,  6, 13,  7,
  6,   8, 12, 9, 24, 10, 48, 11, 96, 12, 36, 13, 8, 14, 16, 15,
};

/*-------------------------------------------------------------------*/
/* Frequency Limit of Rectangle Channels                             */
/*-------------------------------------------------------------------*/
const WORD ApuFreqLimit[8] = 
{
   0x3FF, 0x555, 0x666, 0x71C, 0x787, 0x7C1, 0x7E0, 0x7F0
};

/*-------------------------------------------------------------------*/
/* Noise Frequency Lookup Table                                      */
/*-------------------------------------------------------------------*/
DWORD ApuNoiseFreq[ 16 ] =
{
     4,    8,   16,   32,   64,   96,  128,  160,
   202,  254,  380,  508,  762, 1016, 2034, 4068
};


/*-------------------------------------------------------------------*/
/* DMC Transfer Clocks Table                                         */
/*-------------------------------------------------------------------*/
const DWORD ApuDpcmCycles[ 16 ] = 
{
  428, 380, 340, 320, 286, 254, 226, 214,
  190, 160, 142, 128, 106,  85,  72,  54
};

//***********************************************************
//APU // APU controlAPU
//****************************************************************
BYTE Apu_Read4015(WORD wAddr)
{
    BYTE byRet;    
//        byRet = NES.APU_Reg[ /*0x4015*/0x15 ];
        byRet = APU_Reg4015;
         //APU.

        if ( APU.ApuC1Atl > 0 ) byRet |= (1<<0);
        if ( APU.ApuC2Atl > 0 ) byRet |= (1<<1);
        if ( !ApuC3Holdnote ) {
          if ( APU.ApuC3Atl > 0 ) byRet |= (1<<2);
        } else {
          if ( APU.ApuC3Llc > 0 ) byRet |= (1<<2);
        }

        // FrameIRQ
//    NES.APU_Reg[ /*0x4015*/0x15 ] &= ~0x40;
        APU_Reg4015 &= ~0x40;
        
    return byRet;
}

/*-------------------------------------------------------------------*/
/*   APU Register Write Functions     APU                            */
/*-------------------------------------------------------------------*/
void Apu_Write_i(BYTE bystr,WORD wAddr)
{
//  if ( !NES.APU_Mute )
//  if ( !APU_Mute )
  pAPUSoundRegs[ wAddr & 0xFF]( bystr, wAddr & 0xFF );
}
//*******************************************************************
void Apu_Write4015(BYTE bystr,WORD wAddr)//InfoNES_pAPUWriteControl( wAddr, bystr );
{
  ApuEventQueue[APU.cur_event].time = APU.entertime-clocks ;/*- CPU.g_wPassedClocks;*/
  ApuEventQueue[APU.cur_event].type = APUET_W_CTRL;
  ApuEventQueue[APU.cur_event].str = bystr;
  APU.cur_event++; 
        
 // if ( bystr & 0x10 ) bystr &= ~0x80;        
}

//**************************************************************************

#define APU_WRITEFUNC(name, evtype) \
void ApuWrite##name(WORD addr, BYTE value)\
{ \
  /*ApuEventQueue[APU.cur_event].time = APU.entertime - clocks;*/ \
  /*ApuEventQueue[APU.cur_event].type = APUET_W_##evtype; */\
  /*ApuEventQueue[APU.cur_event].str = value; */\
  /*APU.cur_event++; */\
}


APU_WRITEFUNC(C1a, C1A)
APU_WRITEFUNC(C1b, C1B)
APU_WRITEFUNC(C1c, C1C)
APU_WRITEFUNC(C1d, C1D)

APU_WRITEFUNC(C2a, C2A)
APU_WRITEFUNC(C2b, C2B)
APU_WRITEFUNC(C2c, C2C)
APU_WRITEFUNC(C2d, C2D)

APU_WRITEFUNC(C3a, C3A)
APU_WRITEFUNC(C3b, C3B)
APU_WRITEFUNC(C3c, C3C)
APU_WRITEFUNC(C3d, C3D)

APU_WRITEFUNC(C4a, C4A)
APU_WRITEFUNC(C4b, C4B)
APU_WRITEFUNC(C4c, C4C)
APU_WRITEFUNC(C4d, C4D)

APU_WRITEFUNC(C5a, C5A)
APU_WRITEFUNC(C5b, C5B)
APU_WRITEFUNC(C5c, C5C)
APU_WRITEFUNC(C5d, C5D)

//APU_WRITEFUNC(Control, CTRL);

const ApuWritefunc pAPUSoundRegs[20] = 
{
  ApuWriteC1a,
  ApuWriteC1b,
  ApuWriteC1c,
  ApuWriteC1d,
  ApuWriteC2a,
  ApuWriteC2b,
  ApuWriteC2c,
  ApuWriteC2d,
  ApuWriteC3a,
  ApuWriteC3b,
  ApuWriteC3c,
  ApuWriteC3d,
  ApuWriteC4a,
  ApuWriteC4b,
  ApuWriteC4c,
  ApuWriteC4d,
  ApuWriteC5a,
  ApuWriteC5b,
  ApuWriteC5c,
  ApuWriteC5d,
};

/*===================================================================*/
/*                                                                   */
/*      ApuRenderingWave1() : Rendering Rectangular Wave #1          */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/* Write registers of rectangular wave #1                            */
/*-------------------------------------------------------------------*/

int ApuWriteWave1( int cycles, int event )
{
    /* APU Reg Write Event */
    while ( ( event < APU.cur_event ) && ( ApuEventQueue[event].time < cycles ) )
    {
      if ( ( ApuEventQueue[event].type & APUET_MASK ) == APUET_C1 ) 
      {
        switch ( ApuEventQueue[event].type & 0x03 ) 
        {
        case 0:
          APU.ApuC1a    = ApuEventQueue[event].str;
          APU.ApuC1Wave = (BYTE*)pulse_waves[ ApuC1DutyCycle >> 6 ];
          break;

        case 1:
          APU.ApuC1b    = ApuEventQueue[event].str;
          break;
          
        case 2:
          APU.ApuC1c = ApuEventQueue[event].str;
          APU.ApuC1Freq = ( ( ( (WORD)APU.ApuC1d & 0x07 ) << 8 ) + APU.ApuC1c );
          APU.ApuC1Atl = ApuAtl[ ( APU.ApuC1d & 0xf8 ) >> 3 ];
          
          if ( APU.ApuC1Freq ) 
          {
            APU.ApuC1Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC1Freq;
          } else {
            APU.ApuC1Skip = 0;
          }
          break;

        case 3:
          APU.ApuC1d = ApuEventQueue[event].str;
          APU.ApuC1Freq = ( ( ( (WORD)APU.ApuC1d & 0x07 ) << 8 ) + APU.ApuC1c );
          APU.ApuC1Atl = ApuAtl[ ( APU.ApuC1d & 0xf8 ) >> 3 ];
          
          if ( APU.ApuC1Freq ) 
          {
            APU.ApuC1Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC1Freq;
          } else {
            APU.ApuC1Skip = 0;
          }
          break;
        }
      } 
      else if ( ApuEventQueue[event].type == APUET_W_CTRL ) 
      {
        APU.ApuCtrlNew = ApuEventQueue[event].str;

        if( !(ApuEventQueue[event].str&(1<<0)) ) {
          APU.ApuC1Atl = 0;
        }
      }
      event++;
    }
    return event;
}

/*-------------------------------------------------------------------*/
/* Rendering rectangular wave #1                                     */
/*-------------------------------------------------------------------*/

void ApuRenderingWave1( void )
{
  int cycles = 0;
  int event = 0;
  unsigned int i;
  /* note: 41 CPU cycles occur between increments of i */
  APU.ApuCtrlNew = APU.ApuCtrl;
  for ( i = 0; i < APU.ApuSamplesPerSync; i++ ) 
  {
    /* Write registers */
    cycles += APU.ApuCyclesPerSample;
    event = ApuWriteWave1( cycles, event );

    /* Envelope decay at a rate of ( Envelope Delay + 1 ) / 240 secs */

    APU.ApuC1EnvPhase -= 4;

    /*
     * TODO: using a table of max frequencies is not technically
     * clean, but it is fast and (or should be) accurate
     */
     
    if ( APU.ApuC1Freq < 8 || ( !ApuC1SweepIncDec && APU.ApuC1Freq > ApuC1FreqLimit ) )
    {
      wave_buffers[0][i] = 0;
//          continue;
          break;//ԭ
    }
    /* Frequency sweeping at a rate of ( Sweep Delay + 1) / 120 secs */
    if ( ApuC1SweepOn && ApuC1SweepShifts )     
    {
      APU.ApuC1SweepPhase -= 2;           /* 120/60 */
      if ( APU.ApuC1Freq ) {
        APU.ApuC1Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC1Freq;
      }
    }

    /* Wave Rendering */
    if ( ( APU.ApuCtrlNew & 0x01 ) && ( APU.ApuC1Atl || ApuC1Hold ) ) 
    {
      APU.ApuC1Index += APU.ApuC1Skip;
      APU.ApuC1Index &= 0x1fffffff;
      
      if ( ApuC1Env )
      {
        wave_buffers[0][i] = APU.ApuC1Wave[APU.ApuC1Index >> 24] * ( ApuC1Vol + APU.ApuC1EnvVol );
      } else {
        wave_buffers[0][i] = APU.ApuC1Wave[APU.ApuC1Index >> 24] * ApuC1Vol;
      }
    } else {
      wave_buffers[0][i] = 0;
    }
  }
  if ( APU.ApuC1Atl ) { APU.ApuC1Atl--;  }
}

/*===================================================================*/
/*                                                                   */
/*      ApuRenderingWave2() : Rendering Rectangular Wave #2          */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/* Write registers of rectangular wave #2                           */
/*-------------------------------------------------------------------*/

int ApuWriteWave2( int cycles, int event )
{
    /* APU Reg Write Event */
    while ( ( event < APU.cur_event ) && ( ApuEventQueue[event].time < cycles ) ) 
    {
      if ( ( ApuEventQueue[event].type & APUET_MASK ) == APUET_C2 ) 
      {
        switch ( ApuEventQueue[event].type & 0x03 ) 
        {
        case 0:
          APU.ApuC2a    = ApuEventQueue[event].str;
          APU.ApuC2Wave = (BYTE*)pulse_waves[ ApuC2DutyCycle >> 6 ];
          break;

        case 1:
          APU.ApuC2b    = ApuEventQueue[event].str;
          break;
          
        case 2:
          APU.ApuC2c = ApuEventQueue[event].str;
          APU.ApuC2Freq = ( ( ( (WORD)APU.ApuC2d & 0x07 ) << 8 ) + APU.ApuC2c );
          APU.ApuC2Atl = ApuAtl[ ( APU.ApuC2d & 0xf8 ) >> 3 ];
          
          if ( APU.ApuC2Freq ) 
          {
                  //ApuC2Skip = ApuPulseMagic / (ApuC2Freq / 2);
            APU.ApuC2Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC2Freq;
          } else {
            APU.ApuC2Skip = 0;
          }
          break;

        case 3:
          APU.ApuC2d = ApuEventQueue[event].str;
          APU.ApuC2Freq = ( ( ( (WORD)APU.ApuC2d & 0x07 ) << 8 ) + APU.ApuC2c );
          APU.ApuC2Atl = ApuAtl[ ( APU.ApuC2d & 0xf8 ) >> 3 ];
          
          if ( APU.ApuC2Freq ) 
          {
                  //ApuC2Skip = ApuPulseMagic / (ApuC2Freq / 2);
            APU.ApuC2Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC2Freq;
          } else {
            APU.ApuC2Skip = 0;
          }
          break;
        }
      } 
      else if ( ApuEventQueue[event].type == APUET_W_CTRL ) 
      {
        APU.ApuCtrlNew = ApuEventQueue[event].str;

        if( !(ApuEventQueue[event].str&(1<<1)) ) {
          APU.ApuC2Atl = 0;
        }
      }
      event++;
    }
    return event;
}

/*-------------------------------------------------------------------*/
/* Rendering rectangular wave #2                                     */
/*-------------------------------------------------------------------*/

void ApuRenderingWave2( void )
{
  int cycles = 0;
  int event = 0;
  unsigned int i;
  /* note: 41 CPU cycles occur between increments of i */
  APU.ApuCtrlNew = APU.ApuCtrl;
  for ( i = 0; i < APU.ApuSamplesPerSync; i++ ) 
  {
    /* Write registers */
    cycles += APU.ApuCyclesPerSample;
    event = ApuWriteWave2( cycles, event );

    /* Envelope decay at a rate of ( Envelope Delay + 1 ) / 240 secs */
    APU.ApuC2EnvPhase -= 4;

    /*
     * TODO: using a table of max frequencies is not technically
     * clean, but it is fast and (or should be) accurate
     */
    if ( APU.ApuC2Freq < 8 || ( !ApuC2SweepIncDec && APU.ApuC2Freq > ApuC2FreqLimit ) )
    {
      wave_buffers[1][i] = 0;        //ԭе
          break;
    }

    /* Frequency sweeping at a rate of ( Sweep Delay + 1) / 120 secs */
    if ( ApuC2SweepOn && ApuC2SweepShifts )     
    {
      APU.ApuC2SweepPhase -= 2;           /* 120/60 */
      if ( APU.ApuC2Freq ) {
        APU.ApuC2Skip = ( APU.ApuPulseMagic << 1 ) / APU.ApuC2Freq;
      }
    }

    /* Wave Rendering */
    if ( ( APU.ApuCtrlNew & 0x02 ) && ( APU.ApuC2Atl || ApuC2Hold ) ) 
    {
      APU.ApuC2Index += APU.ApuC2Skip;
      APU.ApuC2Index &= 0x1fffffff;
      
      if ( ApuC2Env )
      {
        wave_buffers[1][i] = APU.ApuC2Wave[APU.ApuC2Index >> 24] * ( ApuC2Vol + APU.ApuC2EnvVol );
      } else {
        wave_buffers[1][i] = APU.ApuC2Wave[APU.ApuC2Index >> 24] * ApuC2Vol;
      }
    } else {
      wave_buffers[1][i] = 0;
    } 
  }
  if ( APU.ApuC2Atl ) { APU.ApuC2Atl--;  }
}

/*===================================================================*/
/*                                                                   */
/*      ApuRenderingWave3() : Rendering Triangle Wave                */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/* Write registers of triangle wave #3                              */
/*-------------------------------------------------------------------*/

int ApuWriteWave3( int cycles, int event )
{
  /* APU Reg Write Event */
  while (( event < APU.cur_event ) && ( ApuEventQueue[event].time < cycles ) ) 
  {
    if ( ( ApuEventQueue[event].type & APUET_MASK ) == APUET_C3 ) 
    {
      switch ( ApuEventQueue[event].type & 3 ) 
      {
      case 0:
        APU.ApuC3a = ApuEventQueue[event].str;
        APU.ApuC3Llc = ApuC3LinearLength;
        break;

      case 1:
        APU.ApuC3b = ApuEventQueue[event].str;
        break;

      case 2:
        APU.ApuC3c = ApuEventQueue[event].str;
        if ( ApuC3Freq ) 
        {
          APU.ApuC3Skip = APU.ApuTriangleMagic / ApuC3Freq;
        } else {
          APU.ApuC3Skip = 0;  
        }
        break;

      case 3:
        APU.ApuC3d = ApuEventQueue[event].str;
        APU.ApuC3Atl = ApuC3LengthCounter;
        if ( ApuC3Freq ) 
        {
          APU.ApuC3Skip = APU.ApuTriangleMagic / ApuC3Freq;
        } else {
          APU.ApuC3Skip = 0;
        }
      }
    } else if ( ApuEventQueue[event].type == APUET_W_CTRL ) {
      APU.ApuCtrlNew = ApuEventQueue[event].str;

      if( !(ApuEventQueue[event].str&(1<<2)) ) {
        APU.ApuC3Atl = 0;
        APU.ApuC3Llc = 0;
      }
    }
    event++;
  }
  return event;
}

/*-------------------------------------------------------------------*/
/* Rendering triangle wave #3                                        */
/*-------------------------------------------------------------------*/

void ApuRenderingWave3( void )
{
  int cycles = 0;
  int event = 0;
  unsigned int i;    
  /* note: 41 CPU cycles occur between increments of i */
  APU.ApuCtrlNew = APU.ApuCtrl;
  for ( i = 0; i < APU.ApuSamplesPerSync; i++) 
  {
    /* Write registers */
    cycles += APU.ApuCyclesPerSample;
    event = ApuWriteWave3( cycles, event );

    /* Cutting Min Frequency */
    if ( ApuC3Freq < 8 )
        {  
          wave_buffers[2][i] = 0;        //////////////////////////////////
           break;
        }
    /* Counter Control */
    if ( APU.ApuC3CounterStarted )
    {
      if ( APU.ApuC3Atl > 0 && !ApuC3Holdnote ) 
      {
        APU.ApuC3Atl--;
      }
      if ( APU.ApuC3Llc > 0 )
      {
        APU.ApuC3Llc--;
      }
    } else if ( !ApuC3Holdnote && APU.ApuC3WriteLatency > 0 ) {
      if ( --APU.ApuC3WriteLatency == 0 )
      {
        APU.ApuC3CounterStarted = 0x01;
      }
    }

    /* Wave Rendering */
    if ( ( APU.ApuCtrlNew & 0x04 ) && ( ( APU.ApuC3Atl > 0 || ApuC3Holdnote ) && APU.ApuC3Llc > 0 ) ) 
    {
      APU.ApuC3Index += APU.ApuC3Skip;
      APU.ApuC3Index &= 0x1fffffff;
          wave_buffers[2][i] = triangle_50[ APU.ApuC3Index >> 24 ];
    } else {
      wave_buffers[2][i] = 0;
    }
  }
}
/*===================================================================*/
/*                                                                   */
/*      ApuRenderingWave4() : Rendering Noise                        */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/* Write registers of noise channel #4                              */
/*-------------------------------------------------------------------*/

int ApuWriteWave4( int cycles, int event )
{
  /* APU Reg Write Event */
  while ( (event < APU.cur_event) && (ApuEventQueue[event].time < cycles) ) 
  {
    if ( ( ApuEventQueue[event].type & APUET_MASK ) == APUET_C4 ) 
    {
      switch (ApuEventQueue[event].type & 3) {
      case 0:
        APU.ApuC4a = ApuEventQueue[event].str;
        break;

      case 1:
        APU.ApuC4b = ApuEventQueue[event].str;
        break;

      case 2:
        APU.ApuC4c = ApuEventQueue[event].str;

        if ( ApuC4Small ) {
          APU.ApuC4Sr = 0x001f;
        } else {
          APU.ApuC4Sr = 0x01ff;
        }

//        /* Frequency */ 
        if (  ApuC4Freq ) {
          APU.ApuC4Skip = APU.ApuNoiseMagic / ApuC4Freq;
        } else {
          APU.ApuC4Skip = 0;
        }
         APU.ApuC4Atl =  ApuC4LengthCounter;
        break;

      case 3:
         APU.ApuC4d = ApuEventQueue[event].str;

        /* Frequency */ 
        if ( ApuC4Freq ) { APU.ApuC4Skip =   APU.ApuNoiseMagic / ApuC4Freq; }           
         else
          {
           APU.ApuC4Skip = 0;
        }
         APU.ApuC4Atl = ApuC4LengthCounter;
      }
    } else if (ApuEventQueue[event].type == APUET_W_CTRL) {
       APU.ApuCtrlNew = ApuEventQueue[event].str;

      if( !(ApuEventQueue[event].str&(1<<3)) ) {
         APU.ApuC4Atl = 0;
      }
    } 
    event++;
  }
  return event;
}

/*-------------------------------------------------------------------*/
/* Rendering noise channel #4                                        */
/*-------------------------------------------------------------------*/

void ApuRenderingWave4(void)
{
  int cycles = 0;
  int event = 0;
  unsigned int i;

   APU.ApuCtrlNew =  APU.ApuCtrl;
  for ( i = 0; i <  APU.ApuSamplesPerSync; i++ ) 
  {
    /* Write registers */
    cycles +=  APU.ApuCyclesPerSample;
    event = ApuWriteWave4( cycles, event );

    /* Envelope decay at a rate of ( Envelope Delay + 1 ) / 240 secs */
     APU.ApuC4EnvPhase -= 4;
//    while (  APU.ApuC4EnvPhase < 0 )
//    {
//       APU.ApuC4EnvPhase += ApuC4EnvDelay;
//
//      if ( ApuC4Hold )
//      {
//         APU.ApuC4EnvVol = (  APU.ApuC4EnvVol + 1 ) & 0x0f;
//      } 
//      else if ( APU.ApuC4EnvVol < 0x0f )
//      {
//        APU.ApuC4EnvVol++;
//      }
//    }

    /* Wave Rendering */
    if (  APU.ApuCtrlNew & 0x08 ) 
    {
      APU.ApuC4Index += APU.ApuC4Skip;
      if ( APU.ApuC4Index > 0x1fffffff ) 
      {
        if ( ApuC4Small )            /* FIXME: may be wrong */
        { 
         APU.ApuC4Sr |= ((!(APU.ApuC4Sr & 1)) ^ (!(APU.ApuC4Sr & 4))) << 5;
        } else {
          APU.ApuC4Sr |= ((!(APU.ApuC4Sr & 1)) ^ (!(APU.ApuC4Sr & 16))) << 9;
        }
        APU.ApuC4Sr >>= 1;
      }
      APU.ApuC4Index &= 0x1fffffff;

      if (  APU.ApuC4Atl && (  APU.ApuC4Sr & 1 ) ) 
      {
        if ( !ApuC4Env )
        {
          wave_buffers[3][i] = ApuC4Vol;
        } else {
          wave_buffers[3][i] =  APU.ApuC4EnvVol ^ 0x0f;
        }
      } else {
        wave_buffers[3][i] = 0;
      }
    } else {
      wave_buffers[3][i] = 0;
    }
  }
  if ( APU.ApuC4Atl && !ApuC4Hold ) 
  {
           APU.ApuC4Atl--;
  }
}

/*===================================================================*/
/*                                                                   */
/*      ApuRenderingWave5() : Rendering DPCM channel #5              */
/*                                                                   */
/*===================================================================*/

/*-------------------------------------------------------------------*/
/* Write registers of DPCM channel #5                               */
/*-------------------------------------------------------------------*/

int ApuWriteWave5( int cycles, int event )
{
  /* APU Reg Write Event */
  while ( (event < APU.cur_event) && (ApuEventQueue[event].time < cycles) ) 
  {
    if ( ( ApuEventQueue[event].type & APUET_MASK ) == APUET_C5 ) 
    {
      APU.ApuC5Reg[ ApuEventQueue[event].type & 3 ] = ApuEventQueue[event].str;

      switch (ApuEventQueue[event].type & 3) {
      case 0:
        APU.ApuC5Freq    = ApuDpcmCycles[ ( ApuEventQueue[event].str & 0x0F ) ] << 16;
        APU.ApuC5Looping = ApuEventQueue[event].str & 0x40;
        break;
      case 1:
        APU.ApuC5DpcmValue = ( ApuEventQueue[event].str & 0x7F ) >> 1;
        break;
      case 2:
        APU.ApuC5CacheAddr = 0xC000 + (WORD)( ApuEventQueue[event].str << 6 );
        break;
      case 3:
        APU.ApuC5CacheDmaLength = ( ( ApuEventQueue[event].str << 4 ) + 1 ) << 3;
        break;
      }
    } else if (ApuEventQueue[event].type == APUET_W_CTRL) {
      APU.ApuCtrlNew = ApuEventQueue[event].str;

      if( !(ApuEventQueue[event].str&(1<<4)) ) {
        APU.ApuC5Enable    = 0;
        APU.ApuC5DmaLength = 0;
      } else {
        APU.ApuC5Enable = 0xFF;
        if( !APU.ApuC5DmaLength ) {
          APU.ApuC5Address   = APU.ApuC5CacheAddr;
          APU.ApuC5DmaLength = APU.ApuC5CacheDmaLength;
        }
      }
    }
    event++;
  }
  return event;
}

/*-------------------------------------------------------------------*/
/* Rendering DPCM channel #5                                         */
/*-------------------------------------------------------------------*/

void ApuRenderingWave5(void)
{
  int cycles = 0;
  int event = 0;
  unsigned int i;
  APU.ApuCtrlNew = APU.ApuCtrl;
  for ( i = 0; i < APU.ApuSamplesPerSync; i++ ) 
  {
    /* Write registers */
    cycles += APU.ApuCyclesPerSample;
    event = ApuWriteWave5( cycles, event );

    if( APU.ApuC5DmaLength ) 
        {
      APU.ApuC5Phaseacc -= APU.ApuCycleRate;

      while( APU.ApuC5Phaseacc < 0 ) 
          {
             APU.ApuC5Phaseacc += APU.ApuC5Freq;
             if( !( APU.ApuC5DmaLength & 7 ) ) 
                 {
               // APU.ApuC5CurByte = K6502_Read( APU.ApuC5Address );         //////////////////////////////////
                if( 0xFFFF == APU.ApuC5Address )APU.ApuC5Address = 0x8000;                
                else APU.ApuC5Address++;            
             }
             if( !(--APU.ApuC5DmaLength) ) 
                 {
               if( APU.ApuC5Looping ) 
                   {
                  APU.ApuC5Address = APU.ApuC5CacheAddr;
                  APU.ApuC5DmaLength = APU.ApuC5CacheDmaLength;
               }else 
                   {
                  APU.ApuC5Enable = 0;
                  break;
               }
             }

                // positive delta
                if( APU.ApuC5CurByte & ( 1 << ((APU.ApuC5DmaLength&7)^7)) )
                {
                  if( APU.ApuC5DpcmValue < 0x3F )        APU.ApuC5DpcmValue += 1;
                    
                } else 
                {
            // negative delta
              if( APU.ApuC5DpcmValue > 1 )        APU.ApuC5DpcmValue -= 1;              
               }
      }
    }
    /* Wave Rendering */
    if ( APU.ApuCtrlNew & 0x10 )         
     { wave_buffers[3][i] = ( APU.ApuC5Reg[1]&0x01 ) + ( APU.ApuC5DpcmValue << 1 );} 
        else  wave_buffers[3][i] = 0;  
  }
}


/*===================================================================*/
/*                                                                   */
/*     InfoNES_pApuVsync() : Callback Function per Vsync             */
/*                                                                   */
/*===================================================================*/

void InfoNES_pAPUVsync(void)
{
//  int i;
//  for(i=0;i<MAX_PCM;i++)wave_buffers[i]=0;

  ApuRenderingWave1();
//  ApuRenderingWave2();
//  ApuRenderingWave3();
//  ApuRenderingWave4();
//  ApuRenderingWave5();
    
  APU.ApuCtrl = APU.ApuCtrlNew;
    
  InfoNES_SoundOutput(APU.ApuSamplesPerSync,wave_buffers[0],wave_buffers[1],wave_buffers[2],wave_buffers[3]);                      

// APU.entertime = CPU.g_wPassedClocks;
  APU.entertime = clocks;
  APU.cur_event = 0;
}

/*===================================================================*/
/*                                                                   */
/*            InfoNES_pApuInit() : Initialize pApu                   */
/*                                                                   */
/*===================================================================*/

void InitTimer4(){
  RCC_APB1ENR.TIM4EN = 1;
  TIM4_CR1.CEN = 0;
  TIM4_PSC = 0;
  TIM4_ARR = 1999;
  NVIC_IntEnable(IVT_INT_TIM4);
  TIM4_DIER.UIE = 1;
  TIM4_CR1.CEN = 1;
}

void Timer4_interrupt() iv IVT_INT_TIM4 {
  TIM4_SR.UIF = 0;
  GPIOB_ODR.B6 =~GPIOB_ODR.B6;
    if(Abuf[zheng][MAX_PCM])
  {
   //DMA1_S5M0AR=Abuf[zheng][DApc];//1 12
   DAC1_Ch1_Output(Abuf[zheng][DApc]);
   DApc++;
 if(DApc==MAX_PCM)
    {
    Abuf[zheng][MAX_PCM]=0;
    DApc=0;
    zheng++;
  if(zheng==Framemun)zheng=0;
    }
    
  }
}

void InfoNES_pAPUInit(void)
{
  /* Sound Hardware Init */
//  InfoNES_SoundInit();

  APU.ApuQuality = pAPU_QUALITY;            // 1: 22050, 2: 44100 [samples/sec]

  APU.ApuPulseMagic      = ApuQual[ APU.ApuQuality ].pulse_magic;
  APU.ApuTriangleMagic   = ApuQual[ APU.ApuQuality ].triangle_magic;
  APU.ApuNoiseMagic      = ApuQual[ APU.ApuQuality ].noise_magic;
  APU.ApuSamplesPerSync  = ApuQual[ APU.ApuQuality ].samples_per_sync;
  APU.ApuCyclesPerSample = ApuQual[ APU.ApuQuality ].cycles_per_sample;
  APU.ApuSampleRate      = ApuQual[ APU.ApuQuality ].sample_rate;
  APU.ApuCycleRate       = ApuQual[ APU.ApuQuality ].cycle_rate;

//  InfoNES_SoundOpen( APU.ApuSamplesPerSync, APU.ApuSampleRate );

  /*-------------------------------------------------------------------*/
  /* Initialize Rectangular, Noise Wave's Regs                         */
  /*-------------------------------------------------------------------*/
  APU.ApuCtrl = APU.ApuCtrlNew = 0;
  APU.ApuC1Wave = (BYTE*)pulse_50;
  APU.ApuC2Wave = (BYTE*)pulse_50;

  APU.ApuC1a = APU.ApuC1b = APU.ApuC1c = APU.ApuC1d = 0;
  APU.ApuC2a = APU.ApuC2b = APU.ApuC2c = APU.ApuC2d = 0;
  APU.ApuC4a = APU.ApuC4b = APU.ApuC4c = APU.ApuC4d = 0;

  APU.ApuC1Skip = APU.ApuC2Skip = 0;
  APU.ApuC1Index = APU.ApuC2Index = 0;
  APU.ApuC1EnvPhase = APU.ApuC2EnvPhase = 0;
  APU.ApuC1EnvVol = APU.ApuC2EnvVol = 0;
  APU.ApuC1Atl = APU.ApuC2Atl = 0;
  APU.ApuC1SweepPhase = APU.ApuC2SweepPhase = 0;
  APU.ApuC1Freq = APU.ApuC2Freq = 0;

  /*-------------------------------------------------------------------*/
  /*   Initialize Triangle Wave's Regs                                 */
  /*-------------------------------------------------------------------*/
  APU.ApuC3a = APU.ApuC3b = APU.ApuC3c = APU.ApuC3d = 0;
  APU.ApuC3Atl = APU.ApuC3Llc = 0;
  APU.ApuC3WriteLatency = 3;                           /* Magic Number */
  APU.ApuC3CounterStarted = 0x00;

  /*-------------------------------------------------------------------*/
  /*   Initialize DPCM's Regs                                          */
  /*-------------------------------------------------------------------*/
  APU.ApuC5Reg[0] = APU.ApuC5Reg[1] = APU.ApuC5Reg[2] = APU.ApuC5Reg[3] = 0;
  APU.ApuC5Enable = APU.ApuC5Looping = APU.ApuC5CurByte = APU.ApuC5DpcmValue = 0;
  APU.ApuC5Freq = APU.ApuC5Phaseacc;
  APU.ApuC5Address = APU.ApuC5CacheAddr = 0;
  APU.ApuC5DmaLength = APU.ApuC5CacheDmaLength = 0;

  /*-------------------------------------------------------------------*/
  /*   Initialize Wave Buffers                                         */
  /*-------------------------------------------------------------------*/
//  InfoNES_MemorySet( (void *)wave_buffers, 0, 1470 );   

//  APU.entertime = CPU.g_wPassedClocks;
    APU.entertime = clocks;
    APU.cur_event = 0;

//  TIM2_PWM_Init(256,1);// ~140khz

    //Dac1_Init();

    DAC1_Init(_DAC_CH1_ENABLE | _DAC_CH2_ENABLE);
    InitTimer4();
    //Timer4_Init(1000000/22050,130);//1MHz
    
}

/*===================================================================*/
/*                                                                   */
/*            InfoNES_pApuDone() : Finalize pApu                     */
/*                                                                   */
/*===================================================================*/

void InfoNES_pAPUDone(void)
{
//  InfoNES_SoundClose();
}

void InfoNES_SoundOutput(int samples,BYTE *wave1,BYTE *wave2,BYTE *wave3,BYTE *wave4)
{        
         int i;
          
            while(Abuf[whichbuf][MAX_PCM]);
          for (i = 0; i < MAX_PCM; i++) 
          {             
                 Abuf[whichbuf][i]=(wave1[i]+wave2[i]+wave3[i])/3;
          }
          Abuf[whichbuf][MAX_PCM]=1;
//          for (i = samples; i < (MAX_PCM-samples); i++)Abuf[whichbuf][i]=0;
          whichbuf++;
          if(whichbuf==Framemun)whichbuf=0;
}

//----------------------------------------------------------------------------------------