#include "Mapper.h"
#include "Waves'NES.h"
#include "Mapper000.h"
#include "Mapper001.h"
#include "Mapper002.h"
#include "Mapper003.h"
#include "Mapper004.h"
#include "Mapper011.h"
#include "Mapper015.h"
#include "Mapper071.h"
#include "Mapper079.h"
#include "Mapper087.h"
#include "Mapper113.h"

MAPPER NES_Mapper;
void Mapper_Init(void)
{
        NES_Mapper.Reset         = Mapper_Reset;
        NES_Mapper.Write         = Mapper_Write;
        NES_Mapper.Read          = Mapper_Read;
        NES_Mapper.WriteLow      = Mapper_WriteLow;
        NES_Mapper.ReadLow       = Mapper_ReadLow;        
        NES_Mapper.ExWrite       = Mapper_ExWrite;
        NES_Mapper.ExRead        = Mapper_ExRead;
        NES_Mapper.ExCmdRead     = Mapper_ExCmdRead;
}

BOOL CreateMapper(int no)
{
        Mapper_Init();
        switch (no)
        {
                case  0:Mapper000_Init();break;
                case  1:Mapper001_Init();break;
                case  2:Mapper002_Init();break;
                case  3:Mapper003_Init();break;
                case  4:Mapper004_Init();break;
                case 11:Mapper011_Init();break;
                case 15:Mapper015_Init();break;
                case 71:Mapper071_Init();break;
                case 79:Mapper079_Init();break;
                case 87:Mapper087_Init();break;
                case 113:Mapper113_Init();break;
                default:break;
        }
        return 1;
}

void Mapper_Reset(void){}

BYTE Mapper_ReadLow(WORD addr)
{
        if(addr>=0x6000&&addr<=0x7FFF)return CPU_MEM_BANK[addr>>13][addr&0x1FFF];
        return (BYTE)(addr>>8);
}

void Mapper_WriteLow(WORD addr,BYTE str)
{
        if(addr>=0x6000&&addr<=0x7FFF)CPU_MEM_BANK[addr>>13][addr&0x1FFF]=str;
}

void Mapper_Write( WORD addr, BYTE str ){}

void Mapper_Read( WORD addr, BYTE str ){}

BYTE Mapper_ExRead( WORD addr )        
{ 
        return 0x00; 
}

void Mapper_ExWrite( WORD addr, BYTE str ){}

BYTE Mapper_ExCmdRead ()        
{ 
        return 0x00; 
}