#ifndef _MAPPER015_H_
#define _MAPPER015_H_


void Mapper015_Reset()
{
        SetPROM_32K_Bank2( 0, 1, 2, 3 );
}

void Mapper015_Write(WORD addr, BYTE str)
{
	switch( addr ) {
		case	0x8000:
			if( str&0x80 ) {
				SetPROM_8K_Bank( 4, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 5, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 6, (str&0x3F)*2+3 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+2 );
			} else {
				SetPROM_8K_Bank( 4, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 5, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 6, (str&0x3F)*2+2 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+3 );
			}
			if( str&0x40 ) SetVRAM_Mirror( VRAM_HMIRROR );
			else		SetVRAM_Mirror( VRAM_VMIRROR );
			break;
		case	0x8001:
			if( str&0x80 ) {
				SetPROM_8K_Bank( 6, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+0 );
			} else {
				SetPROM_8K_Bank( 6, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+1 );
			}
			break;
		case	0x8002:
			if( str&0x80 ) {
				SetPROM_8K_Bank( 4, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 5, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 6, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+1 );
			} else {
				SetPROM_8K_Bank( 4, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 5, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 6, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+0 );
			}
			break;
		case	0x8003:
			if( str&0x80 ) {
				SetPROM_8K_Bank( 6, (str&0x3F)*2+1 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+0 );
			} else {
				SetPROM_8K_Bank( 6, (str&0x3F)*2+0 );
				SetPROM_8K_Bank( 7, (str&0x3F)*2+1 );
			}
			if( str&0x40 ) SetVRAM_Mirror( VRAM_HMIRROR );
			else		SetVRAM_Mirror( VRAM_VMIRROR );
			break;
	}
}

void Mapper015_Init()
{
        NES_Mapper.Reset = Mapper015_Reset;
        NES_Mapper.Write = Mapper015_Write;
}

#endif