#ifndef _MAPPER071_H_
#define _MAPPER071_H_


void Mapper071_Reset()
{
        SetPROM_32K_Bank2( 0, 1, PROM_8K_SIZE-2, PROM_8K_SIZE-1 );
}

void Mapper071_WriteLow(WORD addr, BYTE str)
{
	if( (addr&0xE000)==0x6000 ) {
		SetPROM_16K_Bank( 4, str);
	}
}

void Mapper071_Write(WORD addr, BYTE str)
{
	switch( addr&0xF000 ) {
		case	0x9000:
			if( str&0x10 ) SetVRAM_Mirror( 0x04 );
			else	       SetVRAM_Mirror( 0x03 );
			break;

		case	0xC000:
		case	0xD000:
		case	0xE000:
		case	0xF000:
			SetPROM_16K_Bank( 4, str );
			break;
	}
}

void Mapper071_Init()
{
        NES_Mapper.Reset = Mapper071_Reset;
        NES_Mapper.Write = Mapper071_Write;
        NES_Mapper.WriteLow = Mapper071_WriteLow;
}

#endif