#ifndef _MAPPER113_H_
#define _MAPPER113_H_

void Mapper113_Reset()
{
        SetPROM_32K_Bank1( 0 );
        SetVROM_8K_Bank( 0 );
}

void Mapper113_WriteLow(WORD addr, BYTE str)
{          
        switch( addr ) {
                case        0x4100:
                case        0x4111:
                case        0x4120:
                case        0x4194:
                case        0x4195:
                case        0x4900:
    				if( str & 0x80 ) {
					SetVRAM_Mirror( VRAM_VMIRROR );
				} else {
					SetVRAM_Mirror( VRAM_HMIRROR );
				}
                        SetPROM_32K_Bank1( str >> 3 );
                        SetVROM_8K_Bank( ((str>>3)&0x08)+(str&0x07) );
                        break;
        }
}

void        Mapper113_Write( WORD addr, BYTE str )
{
        switch( addr ) {
                case        0x8008:
                case        0x8009:
                        SetPROM_32K_Bank1( str >> 3 );
                        SetVROM_8K_Bank( ((str>>3)&0x08)+(str&0x07) );
                        break;
                case        0x8E66:
                case        0x8E67:
                        SetVROM_8K_Bank( (str&0x07)?0:1 );
                        break;
                case        0xE00A:
                        SetVRAM_Mirror( VRAM_MIRROR4L );
                        break;
        }
}

void Mapper113_Init()
{
        NES_Mapper.Reset = Mapper113_Reset;
        NES_Mapper.WriteLow = Mapper113_WriteLow;
        NES_Mapper.Write = Mapper113_Write;

}

#endif