#include "TFT_resources.h"
#include "__Lib_FAT32.h"
#include "Menu.c"
#include "Mapper.h"
#include "joypad.c"

// TFT module connections
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOE_ODR.B8;
sbit TFT_RS at GPIOE_ODR.B12;
sbit TFT_CS at GPIOE_ODR.B15;
sbit TFT_RD at GPIOE_ODR.B10;
sbit TFT_WR at GPIOE_ODR.B11;
sbit TFT_BLED at GPIOE_ODR.B9;
// End TFT module connections

sbit Mmc_Chip_Select at GPIOD_ODR.B3;

char err;


void Init_MCU() {
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_7);
  
  SPI3_Init_Advanced(_SPI_FPCLK_DIV128, _SPI_MASTER  | _SPI_8_BIT |
                     _SPI_CLK_IDLE_LOW | _SPI_FIRST_CLK_EDGE_TRANSITION |
                     _SPI_MSB_FIRST | _SPI_SS_DISABLE | _SPI_SSM_ENABLE | _SPI_SSI_1,
                     &_GPIO_MODULE_SPI3_PC10_11_12);
                     
  err = FAT32_Init();
  
  GPIO_Config(&GPIOE_BASE, _GPIO_PINMASK_9, _GPIO_CFG_DIGITAL_OUTPUT);

  delay_ms(1000);
  TFT_BLED = 1;
  TFT_Set_Default_Mode();
  TFT_Init_ILI9341_8bit(320, 240);
  TFT_Fill_Screen(CL_BLACK);
  TFT_Set_Font(&Arial_Unicode_MS_Regular_13x15, CL_WHITE, FO_HORIZONTAL);
  delay_ms(1000);
}

void main() {
        Init_MCU();
        KEY_Init();
        TFT_Fill_Screen(CL_BLACK);
        display_menu();
        
        while(1){

        }
}